﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Syncfusion.OfficeChart;

using System.IO;
using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;

namespace Generate_DocDates.Controllers
{
    public class HomeController : Controller
    {
        public IActionResult Index()
        {
          
            return View();
        }

        public IActionResult GenerateDoc()
        {
            WordDocument document = new WordDocument();

            //Adds section to the document
            IWSection sec = document.AddSection();

            //Adds paragraph to the section
            IWParagraph paragraph = sec.AddParagraph();

            //Inputs data for chart
            object[][] data = new object[4][];

            for (int i = 0; i < 4; i++)
                data[i] = new object[3];

            data[1][0] = new DateTime(2017, 5, 22);
            data[2][0] = new DateTime(2017, 6, 2);
            data[3][0] = new DateTime(2017, 6, 30);


            data[0][1] = "Score";
            data[1][1] = 6;
            data[2][1] = 6;
            data[3][1] = 12;

            data[0][2] = "Norm";
            data[1][2] = 4;
            data[2][2] = 4;
            data[3][2] = 7;

            //Creates and Appends chart to the paragraph 
            WChart chart = paragraph.AppendChart(data, 470, 300);

            //Set the title for Chart.
            chart.ChartTitle = "Chart Sample";

            chart.ChartTitleArea.FontName = "Calibri";
            chart.IsSeriesInRows = false;
            chart.ChartTitleArea.Size = 14;
            chart.ChartArea.Border.LinePattern = OfficeChartLinePattern.None;

            //Sets name to chart series            
            chart.Series[0].SerieType = OfficeChartType.Column_Clustered;
            chart.Series[0].Name = "Score";
            chart.PrimaryValueAxis.Title = "Score";
            chart.PrimaryValueAxis.MaximumValue = 14;
            chart.PrimaryValueAxis.MinimumValue = 0;

            //Sets name to chart series            
            chart.Series[1].SerieType = OfficeChartType.Line;
            chart.Series[1].Name = "Norm";
            chart.Series[1].UsePrimaryAxis = false;
            chart.SecondaryValueAxis.Title = "Norm";
            chart.Series[1].SerieFormat.LineProperties.LineWeight = OfficeChartLineWeight.Medium;


            chart.SecondaryValueAxis.TickLabelPosition = OfficeTickLabelPosition.TickLabelPosition_High;
            chart.SecondaryValueAxis.MajorTickMark = OfficeTickMark.TickMark_Outside;
            // Sets MaximumValue of SecondaryValueAxis.
            chart.SecondaryValueAxis.MaximumValue = 9;
            // Sets MinimumValue of SecondaryValueAxis.
            chart.SecondaryValueAxis.MinimumValue = 1;
            // Sets MajorUnit of SecondaryValueAxis.
            chart.SecondaryValueAxis.MajorUnit = 2;

            chart.Series[0].UsePrimaryAxis = true;
            chart.PrimaryCategoryAxis.CategoryType = OfficeCategoryType.Category;
            //Set the date format of PrimaryCategoryAxis.
            chart.PrimaryCategoryAxis.NumberFormat = "MM-dd-yyyy";


            MemoryStream ms = new MemoryStream();
            document.Save(ms, FormatType.Word2013);
            document.Close();
            ms.Position = 0;
            
            return File(ms, "application/msword", "Chart_Dates.docx");
        }

        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View();
        }
    }
}
